<?php

/*
 * @version $Id: scriptings.php 143 2013-05-30 20:32:41Z hi $
 *
 */

if ((!function_exists('sv')) || preg_match('#acdivs' . DIRECTORY_SEPARATOR . 'scriptings.php#i', sv('PHP_SELF')))
    die('Access denied');

//Scripting-functions included from CMSimple_XH 1.5.2

/**
 * Returns $__text with CMSimple scripting evaluated.
 *
 * @param string $__text
 * @param bool $__compat  Wether only last CMSimple script should be evaluated.
 * @return string
 */
function evaluate_cmsimple_scripting($__text, $__compat = TRUE) {
    global $output;
    foreach ($GLOBALS as $__name => $__dummy) {
        global $$__name;
    }

    $__scope_before = NULL; // just that it exists
    $__scripts = array();
    preg_match_all('~' . $cf['scripting']['regexp'] . '~is', $__text, $__scripts);
    if (count($__scripts[1]) > 0) {
        //$output = preg_replace('~'.$cf['scripting']['regexp'].'~is', '', $__text);
        $output = preg_replace('~#CMSimple (?!hide)(.*?)#~is', '', $__text);
        if ($__compat) {
            $__scripts[1] = array_reverse($__scripts[1]);
        }
        foreach ($__scripts[1] as $__script) {
            if (strtolower($__script) !== 'hide' && strtolower($__script) !== 'remove') {
                $__script = preg_replace(
                        array("'&(quot|#34);'i", "'&(amp|#38);'i", "'&(apos|#39);'i", "'&(lt|#60);'i", "'&(gt|#62);'i", "'&(nbsp|#160);'i"), array("\"", "&", "'", "<", ">", " "), $__script);
                $__scope_before = array_keys(get_defined_vars());
                eval($__script);
                $__scope_after = array_keys(get_defined_vars());
                $__diff = array_diff($__scope_after, $__scope_before);
                foreach ($__diff as $__var) {
                    $GLOBALS[$__var] = $$__var;
                }
                if ($__compat) {
                    break;
                }
            }
        }
        $eval_script_output = $output;
        $output = '';
        return $eval_script_output;
    }
    return $__text;
}

/**
 * Returns $__text with all plugin calls evaluatated.
 * see plugins/index.php preCallPlugins()
 *
 * @param string $__text
 * @return string
 */
function evaluate_plugincall($__text) {
    global $u;

    $error = ' <span style="color:#5b0000; font-size:14px;">{{CALL TO:<span style="color:#c10000;">{{%1}}</span> FAILED}}</span> '; //use this for debugging of failed plugin-calls
    $pl_regex = '"{{{RGX:CALL(.*?)}}}"is'; //general CALL-RegEx (Placeholder: "RGX:CALL")
    $pl_calls = array(
        'PLUGIN:' => 'return {{%1}}',
        'HOME:' => 'return trim(\'<a href="?' . $u[0] . '" title="' . urldecode('{{%1}}') . '">' . urldecode('{{%1}}') . '</a>\');',
        'HOME' => 'return trim(\'<a href="?' . $u[0] . '" title="' . urldecode($u[0]) . '">' . urldecode($u[0]) . '</a>\');'
    );
    $fd_calls = array();
    foreach ($pl_calls AS $regex => $call) {
        preg_match_all(str_replace("RGX:CALL", $regex, $pl_regex), $__text, $fd_calls[$regex]); //catch all PL-CALLS
        foreach ($fd_calls[$regex][0] AS $call_nr => $replace) {
            $call = str_replace("{{%1}}", $fd_calls[$regex][1][$call_nr], $pl_calls[$regex]);
            $fnct_call = preg_replace('"(?:(?:return)\s)*(.*?)\(.*?\);"is', '$1', $call);
            $fnct = function_exists($fnct_call) ? TRUE : FALSE; //without object-calls; functions-only!!
            if ($fnct) {
                preg_match_all("/\\$([a-z_0-9]*)/i", $call, $matches);
                foreach ($matches[1] as $var) {
                    global $$var;
                }
            }
            $__text = str_replace($replace, ($fnct ? eval(str_replace('{{%1}}', $fd_calls[$regex][1][$call_nr], $pl_calls[$regex])) : str_replace('{{%1}}', $regex . $fd_calls[$regex][1][$call_nr], $error)), $__text); //replace PL-CALLS (String only!!)
        }
    }
    return $__text;
}

/**
 * Returns $text with CMSimple scripting and plugin calls evaluated.
 *
 * @param string $text
 * @param bool $compat  Wheter only last CMSimple script will be evaluated.
 * @return void
 */
function evaluate_scripting($text, $compat = TRUE) {
    return evaluate_cmsimple_scripting(evaluate_plugincall($text), $compat);
}